local E, _, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local L = LibStub("AceLocale-3.0"):GetLocale("EnhancedCurrency", false)
local EP = LibStub("LibElvUIPlugin-1.0")

EC.defaults = {
	['debug']						= false,
	['combat']						= true,
	['checkVersion']				= true,
	['session']						= true,
	['hideZero']					= false,
	['colorZero']					= true,
	['zeroColor']					= {r = 0.6, g = 0.6, b = 0.6},
	['tooltipSkin']					= "Transparent",
	['hideUnused']					= true,
	
	-- ldb options
	['ldbText']						= "money",
	['dtLeft']						= "allbags",
	['dtRight']						= "currency",
	['entryLeft']					= "link",
	['entryRight']					= "unused",
	
	-- sections
	['availablefunds']				= true,
	['wowtoken']					= true,
	['dungeonandraid']				= true,
	['miscellaneous']				= true,
	['battleforazeroth']			= true,
	['legion']						= true,
	['warlordsofdraenor']			= true,
	['mistsofpandaria']				= true,
	['cataclysm']					= true,
	['wrathofthelichking']			= true,
	['playervsplayer']				= true,
	['archy']						= true,
	
	-- archaeology options
	['fragments']					= {
		['frag_829']	= true, -- Arakkoa
		['frag_1174']	= true, -- Demonic
		['frag_398']	= true,	-- Draenei
		['frag_821']	= true, -- Draenor Clans
		['frag_1535'] 	= true, -- Drust
		['frag_384']	= true,	-- Dwarf
		['frag_393']	= true,	-- Fossil
		['frag_1172'] 	= true, -- Highborn
		['frag_1173'] 	= true, -- Highmountain Tauren
		['frag_754'] 	= true, -- Mantid
		['frag_677']	= true, -- Mogu
		['frag_400']	= true,	-- Nerubian
		['frag_394']	= true,	-- Night Elf
		['frag_828'] 	= true, -- Ogre
		['frag_397']	= true,	-- Orc
		['frag_676']	= true, -- Pandaren
		['frag_401']	= true,	-- Tol'vir
		['frag_385']	= true,	-- Troll
		['frag_399']	= true,	-- Vrykul
		['frag_1534'] 	= true, -- Zandalari
	},
	
	['toggles']		= {
		['availablefunds']			= true,
		['session']					= true,
		['wowtoken']				= true,
		['dungeonandraid']			= true,
		['miscellaneous']			= true,
		['battleforazeroth']		= true,
		['legion']					= true,
		['warlordsofdraenor']		= true,
		['mistsofpandaria']			= true,
		['cataclysm']				= true,
		['wrathofthelichking']		= true,
		['playervsplayer']			= true,
		['unused']					= true,
		['archaeologyfragments']	= true,
	}
}

curr_gold = curr_gold or {}
curr_db = curr_db or EC.defaults

local function InjectOptions()
	if not E.Options.args.klix then
		E.Options.args.klix = {
			type = "group",
			order = -2,
			name = L["Plugins by |cfff960d9Klix|r"],
			args = {
				thanks = {
					type = "description",
					order = 1,
					name = L["Thanks for using and supporting my work!  --  |cfff960d9Klix|r\n\n|cffff0000If you find any bugs, or have any suggestions for any of my addons, please open a ticket at that particular addon's page on CurseForge or find me on Discord."],
				},
				discordlink = {
					order = 2,
					type = "input",
					width = "full",
					name = L["Join me on Discord!"],
					get = function(info) return L["https://discord.gg/GbQbDRX"] end,
				},
			},
		}
	elseif not E.Options.args.klix.args.thanks then
		E.Options.args.klix.args.thanks = {
			type = "description",
			order = 1,
			name = L["Thanks for using and supporting my work!  --  |cfff960d9Klix|r\n\n|cffff0000If you find any bugs, or have any suggestions for any of my addons, please open a ticket at that particular addon's page on CurseForge or find me on Discord."],
		}
	elseif not E.Options.args.klix.args.discordlink then
		E.Options.args.klix.args.discordlink = {
			order = 2,
			type = "input",
			width = "full",
			name = L["Join me on Discord!"],
			get = function(info) return L["https://discord.gg/GbQbDRX"] end,
		}
	end
	
	E.Options.args.klix.args.currldb = {
		type = "group",
		name = L["Enhanced Currency"],
		childGroups = "tab",
		get = function(info) return curr_db[info[#info]] end,
		set = function(info, value) curr_db[info[#info]] = value end,
		args = {
			header = {
				order = 1,
				type = "header",
				name = L["Enhanced Currency v|cff00ff96%s|r by Klix (EU - Twisting Nether)"]:format(EC.version),
			},
			description = {
				order = 2,
				type = "description",
				name = L["Enhanced Currency provides an extended currency datatext using LibDataBroker and LibQTip!\nBased on ElvUI Currency Datatext by |cff9382c9Lockslap|r."],
			},
			general = {
				order = 3,
				type = "group",
				name = L["General"],
				guiInline = true,
				args = {
					combat = {
						type = "toggle",
						order = 1,
						name = L["Disable In Combat"],
						desc = L["Do not display the tooltip when mousedover in combat."]
					},
					checkVersion = {
						type = "toggle",
						order = 2,
						name = L["Version Check"],
						desc = L["Check for a new version when logging in."]
					},
					space3 = {
						order = 3,
						type = "description",
						name = "",
					},
					resetsettings = {
						type = "execute",
						order = 4,
						name = L["Reset Settings"],
						desc = L["Reset the settings of this addon to their defaults."],
						func = function()
							curr_db = EC.defaults
							EC:UpdateLDBText()
							EC:Print("Settings were reset to defaults.")
						end,
					},
					resetgold = {
						type = "execute",
						order = 5,
						name = L["Reset Gold Totals"],
						desc = L["Reset the character-based gold totals."],
						func = function()
							curr_gold = {}
							EC:Print("Character Gold Totals Reset!")
						end,
					},
					gotogold = {
						order = 11,
						type = "execute",
						name = L["ElvUI Gold Settings"],
						desc = L["Change gold output style.\n|cff00ff96Note: For the Gold Format to change on the databroker, please do a /rl after changing settings.|r"],
						func = function()
							LibStub("AceConfigDialog-3.0-ElvUI"):SelectGroup("ElvUI", "datatexts", "currencies")
						end,
					},
				},
			},
			ldbOptions = {
				order = 4,
				type = "group",
				name = L["LDB Options"],
				guiInline = true,
				args = {
					ldbText = {
						type = "select",
						order = 1,
						name = L["LDB Display Mode"],
						desc = L["What do you want displayed in the datatext."],
						values = {
							["money"] = L["Money"],
							["bags"] = L["Bags"],
						},
						set = function(info, value)
							curr_db[info[#info]] = value
							EC:UpdateLDBText()
						end,
					},
					dtLeft = {
						type = "select",
						order = 2,
						name = L["Datatext Left Click"],
						desc = L["Action when the datatext is left clicked."],
						values = {
							["character"]	= L["Toggle Character Frame"],
							["pet"]			= L["Toggle Pet Frame"],
							["reputation"]	= L["Toggle Reputation Frame"],
							["currency"]	= L["Toggle Currency Frame"],
							["allbags"]		= L["Toggle All Bags"],
							["guild"]		= L["Toggle Guild Frame"],
							["friends"]		= L["Toggle Friends Frame"],
							["bag1"]		= L["Toggle Bag 1"],
							["bag2"]		= L["Toggle Bag 2"],
							["bag3"]		= L["Toggle Bag 3"],
							["bag4"]		= L["Toggle Bag 4"],
							["garbage"]		= L["Garbage Collect"],
						}
					},
					dtRight = {
						type = "select",
						order = 3,
						name = L["Datatext Right Click"],
						desc = L["Action when the data text is right clicked."],
						values = {
							["character"]	= L["Toggle Character Frame"],
							["pet"]			= L["Toggle Pet Frame"],
							["reputation"]	= L["Toggle Reputation Frame"],
							["currency"]	= L["Toggle Currency Frame"],
							["allbags"]		= L["Toggle All Bags"],
							["guild"]		= L["Toggle Guild Frame"],
							["friends"]		= L["Toggle Friends Frame"],
							["bag1"]		= L["Toggle Bag 1"],
							["bag2"]		= L["Toggle Bag 2"],
							["bag3"]		= L["Toggle Bag 3"],
							["bag4"]		= L["Toggle Bag 4"],
							["garbage"]		= L["Garbage Collect"],
						}
					},
					entryLeft = {
						type = "select",
						order = 4,
						name = L["Entry Left Click"],
						desc = L["Action when an entry is left clicked."],
						values = {
							["unused"]		= L["Toggle Unused"],
							["watched"]		= L["Toggle Watched"],
							["link"]		= L["Create Link"],
						},
					},
					entryRight = {
						type = "select",
						order = 4,
						name = L["Entry Right Click"],
						desc = L["Action when an entry is right clicked."],
						values = {
							["unused"]		= L["Toggle Unused"],
							["watched"]		= L["Toggle Watched"],
							["link"]		= L["Create Link"],
						},
					},
				}
			},
			sections = {
				order = 5,
				type = "group",
				name = L["Sections"],
				guiInline = true,
				args = {
					availablefunds = {
						type = "toggle",
						order = 1,
						name = L["Available Funds"],
						desc = L["Show/hide the Available Funds section."],
					},
					wowtoken = {
						type = "toggle",
						order = 2,
						name = L["WoW Token"],
						desc = L["Show/hide the WoW Token section."],
					},
					dungeonandraid = {
						type = "toggle",
						order = 3,
						name = L["Dungeon and Raid"],
						desc = L["Show/hide the Dungeon and Raid section."],
					},
					miscellaneous = {
						type = "toggle",
						order = 4,
						name = L["Miscellaneous"],
						desc = L["Show/hide the Miscellaneous section."],
					},
					playervsplayer = {
						type = "toggle",
						order = 5,
						name = L["Player vs. Player"],
						desc = L["Show/hide the Player vs. Player section."],
					},
					archy = {
						type = "toggle",
						order = 6,
						disabled = function() return not EC:HasArchaeology() end,
						name = L["Archaeology"],
						desc = L["Show/hide the Archaeology section."]
					},
					expansions = {
						order = 7,
						type = "group",
						name = L["Expansions"],
						guiInline = true,
						args = {
							battleforazeroth = {
								type = "toggle",
								order = 1,
								name = L["Battle for Azeroth"],
								desc = L["Show/hide the Battle for Azeroth section."],
							},
							legion = {
								type = "toggle",
								order = 2,
								name = L["Legion"],
								desc = L["Show/hide the Legion section."],
							},
							warlordsofdraenor = {
								type = "toggle",
								order = 3,
								name = L["Warlords of Draenor"],
								desc = L["Show/hide the Warlords of Draenor section."],
							},
							mistsofpandaria = {
								type = "toggle",
								order = 4,
								name = L["Mists of Pandaria"],
								desc = L["Show/hide the Mists of Pandaria section."],
							},
							cataclysm = {
								type = "toggle",
								order = 5,
								name = L["Cataclysm"],
								desc = L["Show/hide the Cataclysm section."],
							},
							wrathofthelichking = {
								type = "toggle",
								order = 6,
								name = L["Wrath of the Lich King"],
								desc = L["Show/hide the Wrath of the Lich King section."],
							},
						},
					},
				}
			},
			display = {
				order = 6,
				type = "group",
				name = L["Display Options"],
				guiInline = true,
				args = {
					tooltipSkin = {
						type = "select",
						order = 2,
						name = L["Tooltip Skin"],
						desc = L["Choose a skin to use for the tooltip."],
						values = {
							["Transparent"] = L["Transparent"],
							["Default"] = L["Default"],
						},
					},
					hideUnused = {
						type = "toggle",
						order = 3,
						name = L["Hide Unused"],
						desc = L["Hide currencies marked as unused."]
					},
					hideZero = {
						type = "toggle",
						order = 4,
						name = L["Hide Zero Entries"],
						desc = L["Hide currencies who's quantity is zero (0)."]
					},
					colorZero = {
						type = "toggle",
						order = 5,
						name = L["Color Zero Entries"],
						desc = L["Color currencies who's quantity is zero (0) differently."],
						set = function(info, value)
							curr_db[info[#info]] = value
							if value == true then curr_db.hideZero = false end
						end,
					},
					zeroColor = {
						type = "color",
						order = 6,
						name = L["Zero Quantity Color"],
						desc = L["Color of currencies who's quantity is zero (0)."],
						get = function(info)
							local t = curr_db[info[#info]]
							return t.r, t.g, t.b
						end,
						set = function(info, r, g, b)
							curr_db[info[#info]].r = r
							curr_db[info[#info]].g = g
							curr_db[info[#info]].b = b
						end,
					},
					session = {
						type = "toggle",
						order = 3,
						name = L["Display Session Data"],
						desc = L["Add session data to the tooltip."],
					},
				}
			},
			archy = {
				order = 7,
				type = "group",
				name = L["Archaeology Fragments"],
				guiInline = true,
				disabled = function() return not EC:HasArchaeology() end,
				get = function(info) return curr_db.fragments[info[#info]] end,
				set = function(info, value) curr_db.fragments[info[#info]] = value end,
				args = {
					frag_829 = {	-- Arakkoa
						type = "toggle",
						order = 1,
						disabled = function() return not curr_db.archy end,
						name = L["Arakkoa"],
						desc = L["Show Arakkoa fragments."],
					},
					frag_1174 = {	-- Demonic
						type = "toggle",
						order = 2,
						disabled = function() return not curr_db.archy end,
						name = L["Demonic"],
						desc = L["Show Demonic fragments."],
					},
					frag_398 = {	-- Draenei
						type = "toggle",
						order = 3,
						disabled = function() return not curr_db.archy end,
						name = L["Draenei"],
						desc = L["Show Draenei fragments."],
					},
					frag_821 = {	-- Draenor Clans
						type = "toggle",
						order = 4,
						disabled = function() return not curr_db.archy end,
						name = L["Draenor Clans"],
						desc = L["Show Draenor Clans fragments."],
					},
					frag_1535 = {	-- Drust
						type = "toggle",
						order = 5,
						disabled = function() return not curr_db.archy end,
						name = L["Drust"],
						desc = L["Show Drust fragments."],
					},
					frag_384 = {	-- Dwarf
						type = "toggle",
						order = 6,
						disabled = function() return not curr_db.archy end,
						name = L["Dwarf"],
						desc = L["Show Dwarf fragments."],
					},
					frag_393 = {	-- Fossil
						type = "toggle",
						order = 7,
						disabled = function() return not curr_db.archy end,
						name = L["Fossil"],
						desc = L["Show Fossil fragments."],
					},
					frag_1172 = {	-- Highborn
						type = "toggle",
						order = 8,
						disabled = function() return not curr_db.archy end,
						name = L["Highborn"],
						desc = L["Show Highborn fragments."],
					},
					frag_1173 = {	-- Highmountain Tauren
						type = "toggle",
						order = 9,
						disabled = function() return not curr_db.archy end,
						name = L["Highmountain Tauren"],
						desc = L["Show Highmountain Tauren fragments."],
					},
					frag_754 = {	-- Mantid
						type = "toggle",
						order = 10,
						disabled = function() return not curr_db.archy end,
						name = L["Mantid"],
						desc = L["Show Mantid fragments."],
					},
					frag_677 = {	-- Mogu
						type = "toggle",
						order = 11,
						disabled = function() return not curr_db.archy end,
						name = L["Mogu"],
						desc = L["Show Mogu fragments."],
					},
					frag_400 = {	-- Nerubian
						type = "toggle",
						order = 12,
						disabled = function() return not curr_db.archy end,
						name = L["Nerubian"],
						desc = L["Show Nerubian fragments."],
					},
					frag_394 = {	-- Night Elf
						type = "toggle",
						order = 13,
						disabled = function() return not curr_db.archy end,
						name = L["Night Elf"],
						desc = L["Show Night Elf fragments."],
					},
					frag_828 = {	-- Ogre
						type = "toggle",
						order = 14,
						disabled = function() return not curr_db.archy end,
						name = L["Ogre"],
						desc = L["Show Ogre fragments."],
					},
					frag_397 = {	-- Orc
						type = "toggle",
						order = 15,
						disabled = function() return not curr_db.archy end,
						name = L["Orc"],
						desc = L["Show Orc fragments."],
					},
					frag_676 = {	-- Pandaren
						type = "toggle",
						order = 16,
						disabled = function() return not curr_db.archy end,
						name = L["Pandaren"],
						desc = L["Show Pandaren fragments."],
					},
					frag_401 = {	-- Tol'vir
						type = "toggle",
						order = 17,
						disabled = function() return not curr_db.archy end,
						name = L["Tol'vir"],
						desc = L["Show Tol'vir fragments."],
					},
					frag_385 = {	-- Troll
						type = "toggle",
						order = 18,
						disabled = function() return not curr_db.archy end,
						name = L["Troll"],
						desc = L["Show Troll fragments."],
					},
					frag_399 = {	-- Vrykul
						type = "toggle",
						order = 19,
						disabled = function() return not curr_db.archy end,
						name = L["Vrykul"],
						desc = L["Show Vrykul fragments."]
					},
					frag_1534 = {	-- Zandalari
						type = "toggle",
						order = 20,
						disabled = function() return not curr_db.archy end,
						name = L["Zandalari"],
						desc = L["Show Zandalari fragments."],
					},
				}
			},
		}
	}
end

EP:RegisterPlugin(..., InjectOptions)